import '../../editor.api.js';
import { IStandaloneEditorConstructionOptions, IStandaloneCodeEditor, IStandaloneDiffEditorConstructionOptions, IStandaloneDiffEditor } from './standaloneCodeEditor.js';
import { IEditorOverrideServices } from './standaloneServices.js';

/**
 * Create a new editor under `domElement`.
 * `domElement` should be empty (not contain other dom nodes).
 * The editor will read the size of `domElement`.
 */
declare function create(domElement: HTMLElement, options?: IStandaloneEditorConstructionOptions, override?: IEditorOverrideServices): IStandaloneCodeEditor;
/**
 * Create a new diff editor under `domElement`.
 * `domElement` should be empty (not contain other dom nodes).
 * The editor will read the size of `domElement`.
 */
declare function createDiffEditor(domElement: HTMLElement, options?: IStandaloneDiffEditorConstructionOptions, override?: IEditorOverrideServices): IStandaloneDiffEditor;

export { create, createDiffEditor };
