import { ServiceIdentifier } from '../../instantiation/common/instantiation.js';
import { URI } from '../../../base/common/uri.js';
import { IQuickPickItem } from '../../quickinput/common/quickInput.js';
import { IGalleryExtension } from '../../extensionManagement/common/extensionManagement.js';

interface ILanguagePackItem extends IQuickPickItem {
    readonly extensionId?: string;
    readonly galleryExtension?: IGalleryExtension;
}
declare const ILanguagePackService: ServiceIdentifier<ILanguagePackService>;
interface ILanguagePackService {
    readonly _serviceBrand: undefined;
    getAvailableLanguages(): Promise<Array<ILanguagePackItem>>;
    getInstalledLanguages(): Promise<Array<ILanguagePackItem>>;
    getBuiltInExtensionTranslationsUri(id: string, language: string): Promise<URI | undefined>;
}

export { type ILanguagePackItem, ILanguagePackService };
