import { localizeWithPath } from '../../../../nls.js';
import { Color, RGBA } from '../../../../base/common/color.js';
import { registerColor, oneOf } from '../colorUtils.js';
import { editorWidgetBackground, editorWidgetForeground } from './editorColors.js';
import { listActiveSelectionForeground, listActiveSelectionIconForeground, listActiveSelectionBackground } from './listColors.js';
const quickInputBackground = registerColor('quickInput.background', { dark: editorWidgetBackground, light: editorWidgetBackground, hcDark: editorWidgetBackground, hcLight: editorWidgetBackground }, ( localizeWithPath(
 'vs/platform/theme/common/colors/quickpickColors',
 'pickerBackground',
 "Quick picker background color. The quick picker widget is the container for pickers like the command palette."
)));
const quickInputForeground = registerColor('quickInput.foreground', { dark: editorWidgetForeground, light: editorWidgetForeground, hcDark: editorWidgetForeground, hcLight: editorWidgetForeground }, ( localizeWithPath(
 'vs/platform/theme/common/colors/quickpickColors',
 'pickerForeground',
 "Quick picker foreground color. The quick picker widget is the container for pickers like the command palette."
)));
const quickInputTitleBackground = registerColor('quickInputTitle.background', { dark: ( new Color(( new RGBA(255, 255, 255, 0.105)))), light: ( new Color(( new RGBA(0, 0, 0, 0.06)))), hcDark: '#000000', hcLight: Color.white }, ( localizeWithPath(
 'vs/platform/theme/common/colors/quickpickColors',
 'pickerTitleBackground',
 "Quick picker title background color. The quick picker widget is the container for pickers like the command palette."
)));
const pickerGroupForeground = registerColor('pickerGroup.foreground', { dark: '#3794FF', light: '#0066BF', hcDark: Color.white, hcLight: '#0F4A85' }, ( localizeWithPath(
 'vs/platform/theme/common/colors/quickpickColors',
 'pickerGroupForeground',
 "Quick picker color for grouping labels."
)));
const pickerGroupBorder = registerColor('pickerGroup.border', { dark: '#3F3F46', light: '#CCCEDB', hcDark: Color.white, hcLight: '#0F4A85' }, ( localizeWithPath(
 'vs/platform/theme/common/colors/quickpickColors',
 'pickerGroupBorder',
 "Quick picker color for grouping borders."
)));
const _deprecatedQuickInputListFocusBackground = registerColor('quickInput.list.focusBackground', { dark: null, light: null, hcDark: null, hcLight: null }, '', undefined, ( localizeWithPath(
 'vs/platform/theme/common/colors/quickpickColors',
 'quickInput.list.focusBackground deprecation',
 "Please use quickInputList.focusBackground instead"
)));
const quickInputListFocusForeground = registerColor('quickInputList.focusForeground', { dark: listActiveSelectionForeground, light: listActiveSelectionForeground, hcDark: listActiveSelectionForeground, hcLight: listActiveSelectionForeground }, ( localizeWithPath(
 'vs/platform/theme/common/colors/quickpickColors',
 'quickInput.listFocusForeground',
 "Quick picker foreground color for the focused item."
)));
const quickInputListFocusIconForeground = registerColor('quickInputList.focusIconForeground', { dark: listActiveSelectionIconForeground, light: listActiveSelectionIconForeground, hcDark: listActiveSelectionIconForeground, hcLight: listActiveSelectionIconForeground }, ( localizeWithPath(
 'vs/platform/theme/common/colors/quickpickColors',
 'quickInput.listFocusIconForeground',
 "Quick picker icon foreground color for the focused item."
)));
const quickInputListFocusBackground = registerColor('quickInputList.focusBackground', { dark: oneOf(_deprecatedQuickInputListFocusBackground, listActiveSelectionBackground), light: oneOf(_deprecatedQuickInputListFocusBackground, listActiveSelectionBackground), hcDark: null, hcLight: null }, ( localizeWithPath(
 'vs/platform/theme/common/colors/quickpickColors',
 'quickInput.listFocusBackground',
 "Quick picker background color for the focused item."
)));
export { _deprecatedQuickInputListFocusBackground, pickerGroupBorder, pickerGroupForeground, quickInputBackground, quickInputForeground, quickInputListFocusBackground, quickInputListFocusForeground, quickInputListFocusIconForeground, quickInputTitleBackground };
