import { Color, RGBA } from '../../../../base/common/color.js';
import { localizeWithPath } from '../../../../nls.js';
import { registerColor, transparent } from '../../../../platform/theme/common/colorUtils.js';
import { contrastBorder, foreground } from '../../../../platform/theme/common/colors/baseColors.js';
import '../../../../platform/theme/common/colors/chartsColors.js';
import { editorWidgetBackground, editorBackground } from '../../../../platform/theme/common/colors/editorColors.js';
import '../../../../platform/theme/common/colors/inputColors.js';
import '../../../../platform/theme/common/colors/listColors.js';
import '../../../../platform/theme/common/colors/menuColors.js';
import '../../../../platform/theme/common/colors/minimapColors.js';
import { badgeBackground, badgeForeground } from '../../../../platform/theme/common/colors/miscColors.js';
import '../../../../platform/theme/common/colors/quickpickColors.js';
import '../../../../platform/theme/common/colors/searchColors.js';
registerColor('chat.requestBorder', { dark: ( new Color(( new RGBA(255, 255, 255, 0.10)))), light: ( new Color(( new RGBA(0, 0, 0, 0.10)))), hcDark: contrastBorder, hcLight: contrastBorder, }, ( localizeWithPath(
 'vs/workbench/contrib/chat/common/chatColors',
 'chat.requestBorder',
 'The border color of a chat request.'
)));
const chatRequestBackground = registerColor('chat.requestBackground', { dark: ( transparent(editorBackground, 0.62)), light: ( transparent(editorBackground, 0.62)), hcDark: editorWidgetBackground, hcLight: null }, ( localizeWithPath(
 'vs/workbench/contrib/chat/common/chatColors',
 'chat.requestBackground',
 'The background color of a chat request.'
)));
const chatSlashCommandBackground = registerColor('chat.slashCommandBackground', { dark: '#34414B', light: '#D2ECFF', hcDark: Color.white, hcLight: badgeBackground }, ( localizeWithPath(
 'vs/workbench/contrib/chat/common/chatColors',
 'chat.slashCommandBackground',
 'The background color of a chat slash command.'
)));
const chatSlashCommandForeground = registerColor('chat.slashCommandForeground', { dark: '#40A6FF', light: '#306CA2', hcDark: Color.black, hcLight: badgeForeground }, ( localizeWithPath(
 'vs/workbench/contrib/chat/common/chatColors',
 'chat.slashCommandForeground',
 'The foreground color of a chat slash command.'
)));
registerColor('chat.avatarBackground', { dark: '#1f1f1f', light: '#f2f2f2', hcDark: Color.black, hcLight: Color.white, }, ( localizeWithPath(
 'vs/workbench/contrib/chat/common/chatColors',
 'chat.avatarBackground',
 'The background color of a chat avatar.'
)));
registerColor('chat.avatarForeground', { dark: foreground, light: foreground, hcDark: foreground, hcLight: foreground, }, ( localizeWithPath(
 'vs/workbench/contrib/chat/common/chatColors',
 'chat.avatarForeground',
 'The foreground color of a chat avatar.'
)));
export { chatRequestBackground, chatSlashCommandBackground, chatSlashCommandForeground };
