import { Codicon } from '../../../../base/common/codicons.js';
import { localizeWithPath } from '../../../../nls.js';
import { registerIcon } from '../../../../platform/theme/common/iconRegistry.js';
const settingsScopeDropDownIcon = registerIcon('settings-folder-dropdown', Codicon.triangleDown, ( localizeWithPath(
 'vs/workbench/contrib/preferences/browser/preferencesIcons',
 'settingsScopeDropDownIcon',
 'Icon for the folder dropdown button in the split JSON Settings editor.'
)));
const settingsMoreActionIcon = registerIcon('settings-more-action', Codicon.gear, ( localizeWithPath(
 'vs/workbench/contrib/preferences/browser/preferencesIcons',
 'settingsMoreActionIcon',
 'Icon for the \'more actions\' action in the Settings UI.'
)));
const keybindingsRecordKeysIcon = registerIcon('keybindings-record-keys', Codicon.recordKeys, ( localizeWithPath(
 'vs/workbench/contrib/preferences/browser/preferencesIcons',
 'keybindingsRecordKeysIcon',
 'Icon for the \'record keys\' action in the keybinding UI.'
)));
const keybindingsSortIcon = registerIcon('keybindings-sort', Codicon.sortPrecedence, ( localizeWithPath(
 'vs/workbench/contrib/preferences/browser/preferencesIcons',
 'keybindingsSortIcon',
 'Icon for the \'sort by precedence\' toggle in the keybinding UI.'
)));
const keybindingsEditIcon = registerIcon('keybindings-edit', Codicon.edit, ( localizeWithPath(
 'vs/workbench/contrib/preferences/browser/preferencesIcons',
 'keybindingsEditIcon',
 'Icon for the edit action in the keybinding UI.'
)));
const keybindingsAddIcon = registerIcon('keybindings-add', Codicon.add, ( localizeWithPath(
 'vs/workbench/contrib/preferences/browser/preferencesIcons',
 'keybindingsAddIcon',
 'Icon for the add action in the keybinding UI.'
)));
const settingsEditIcon = registerIcon('settings-edit', Codicon.edit, ( localizeWithPath(
 'vs/workbench/contrib/preferences/browser/preferencesIcons',
 'settingsEditIcon',
 'Icon for the edit action in the Settings UI.'
)));
const settingsRemoveIcon = registerIcon('settings-remove', Codicon.close, ( localizeWithPath(
 'vs/workbench/contrib/preferences/browser/preferencesIcons',
 'settingsRemoveIcon',
 'Icon for the remove action in the Settings UI.'
)));
const settingsDiscardIcon = registerIcon('settings-discard', Codicon.discard, ( localizeWithPath(
 'vs/workbench/contrib/preferences/browser/preferencesIcons',
 'preferencesDiscardIcon',
 'Icon for the discard action in the Settings UI.'
)));
const preferencesClearInputIcon = registerIcon('preferences-clear-input', Codicon.clearAll, ( localizeWithPath(
 'vs/workbench/contrib/preferences/browser/preferencesIcons',
 'preferencesClearInput',
 'Icon for clear input in the Settings and keybinding UI.'
)));
const preferencesFilterIcon = registerIcon('preferences-filter', Codicon.filter, ( localizeWithPath(
 'vs/workbench/contrib/preferences/browser/preferencesIcons',
 'settingsFilter',
 'Icon for the button that suggests filters for the Settings UI.'
)));
const preferencesOpenSettingsIcon = registerIcon('preferences-open-settings', Codicon.goToFile, ( localizeWithPath(
 'vs/workbench/contrib/preferences/browser/preferencesIcons',
 'preferencesOpenSettings',
 'Icon for open settings commands.'
)));
export { keybindingsAddIcon, keybindingsEditIcon, keybindingsRecordKeysIcon, keybindingsSortIcon, preferencesClearInputIcon, preferencesFilterIcon, preferencesOpenSettingsIcon, settingsDiscardIcon, settingsEditIcon, settingsMoreActionIcon, settingsRemoveIcon, settingsScopeDropDownIcon };
