import { localizeWithPath } from '../../../../nls.js';
import { Extensions as Extensions$1 } from '../../../../platform/configuration/common/configurationRegistry.js';
import { Registry } from '../../../../platform/registry/common/platform.js';
import { workbenchConfigurationNodeBase } from '../../../common/configuration.js';
import { Extensions } from '../../../common/contributions.js';
import { SashSettingsController } from './sash.js';
import { isIOS } from '../../../../base/common/platform.js';
( Registry.as(Extensions.Workbench))
    .registerWorkbenchContribution(SashSettingsController, 3 );
( Registry.as(Extensions$1.Configuration))
    .registerConfiguration({
    ...workbenchConfigurationNodeBase,
    properties: {
        'workbench.sash.size': {
            type: 'number',
            default: isIOS ? 20 : 4,
            minimum: 1,
            maximum: 20,
            description: ( localizeWithPath(
                'vs/workbench/contrib/sash/browser/sash.contribution',
                'sashSize',
                "Controls the feedback area size in pixels of the dragging area in between views/editors. Set it to a larger value if you feel it's hard to resize views using the mouse."
            ))
        },
        'workbench.sash.hoverDelay': {
            type: 'number',
            default: 300,
            minimum: 0,
            maximum: 2000,
            description: ( localizeWithPath(
                'vs/workbench/contrib/sash/browser/sash.contribution',
                'sashHoverDelay',
                "Controls the hover feedback delay in milliseconds of the dragging area in between views/editors."
            ))
        },
    }
});
